    PROGRAM

    !- Hand code sample of the Rich Edit Control

    MAP
        INCLUDE('sRE.INC')
    END
    INCLUDE('keycodes.clw')

w    WINDOW('Clarion Rich Edit'),AT(,,234,217),FONT('MS Sans Serif',8,,FONT:regular),CENTER,IMM,SYSTEM, |
         GRAY,MAX,RESIZE
       TOOLBAR,AT(0,0,,16),USE(?Toolbar)
         BUTTON('B'),AT(1,1,13,14),USE(?BoldButton),FONT(,,,FONT:bold)
         BUTTON('I'),AT(14,1,13,14),USE(?ItalicButton),FONT(,,,FONT:bold+FONT:italic)
         BUTTON('U'),AT(27,1,13,14),USE(?UnderlineButton),FONT(,,,FONT:bold+FONT:underline)
         BUTTON('A'),AT(40,1,13,14),USE(?SetFontButton),FONT(,,,FONT:bold)
         BUTTON('Load File'),AT(74,1,37,14),USE(?LoadFileButton)
         BUTTON('Save File'),AT(112,1,37,14),USE(?SaveFileButton)
       END
     END

reHwnd      LONG

SampleText  CSTRING(20)
b           BYTE
    CODE
    OPEN(w)
    ACCEPT
        CASE EVENT()
            OF EVENT:OpenWindow
                0{PROP:Pixels} = TRUE
                reHwnd = RECreate(w{PROP:ClientHandle},SYSTEM{PROP:AppInstance})
                b = 1
                SampleText = 'Courier New'
                RESetFont(reHwnd,SampleText,b)
                RESetPointSize(reHwnd,12,b)
                POST(EVENT:Accepted,?LoadFileButton)
                w{PROP:Maximize} = 1
                DO SizeRE
                RESetFocus(reHwnd)
            OF EVENT:CloseWindow
                REDestroy(reHwnd)
            OF EVENT:Sized
                DO SizeRE
        END!CASE
        CASE FIELD()
            OF ?BoldButton
                CASE EVENT()
                    OF EVENT:Accepted
                        REToggleBold(reHwnd)
                END
            OF ?ItalicButton
                CASE EVENT()
                    OF EVENT:Accepted
                        REToggleItalic(reHwnd)
                END
            OF ?UnderlineButton
                CASE EVENT()
                    OF EVENT:Accepted
                        REToggleUnderline(reHwnd)
                END
            OF ?SetFontButton
                CASE EVENT()
                    OF EVENT:Accepted
                        RESelectFont(reHwnd)
                END
            OF ?LoadFileButton
                CASE EVENT()
                    OF EVENT:Accepted
                        SampleText = 'readme.rtf'
                        IF RELoadFromFile(reHwnd,SampleText)
                            STOP('Error loading file')
                        END
                        MESSAGE(SampleText & ' loaded.','Rich Edit',ICON:QUESTION)
                END
            OF ?SaveFileButton
                CASE EVENT()
                    OF EVENT:Accepted
                        SampleText = 'readme.rtf'
                        IF RESaveToFile(reHwnd,SampleText)
                            STOP('Error saving file')
                        END
                        MESSAGE(SampleText & ' saved.','Rich Edit',ICON:QUESTION)
                END
        END
    END
    CLOSE(w)

SizeRE  ROUTINE
    DATA
wi   LONG
hi   LONG
    CODE
    wi = 0{PROP:Width} - 1
    hi = 0{PROP:Height} - ?Toolbar{PROP:Height} - 1
    REMove(reHwnd,1,1,wi,hi)


